# Contributing

We are happy to accept contributions!

## Developing

### FFI

The Dart code in this library communicates with the Updater (part of Shorebird's
Flutter engine) via FFI.

For an Updater function to be visible to the Dart code, it must:

1. Be declared in c_api.rs as `pub extern "C"`.
   1. This will add the function to the `library/include/updater.h` header
      file, which is generated by [cbindgen](https://github.com/mozilla/cbindgen)
      when the Updater is built.
1. Be included in the generated ffi bindings. These can be regenerated using
   `dart run ffigen`.
1. Android specific: be listed in
   https://github.com/shorebirdtech/engine/blob/main/shell/platform/android/android_exports.lst
